#include "Initialisierung.h"
#include <Schrift.h>

Knopf *initKnopf( int x, int y, int br, int h, Schrift *zSchrift, __int64 style, char *titel )
{
    Knopf *ret = new Knopf();
    ret->addStyle( style );
    ret->setPosition( x, y );
    ret->setSize( br, h );
    if( zSchrift )
        ret->setSchriftZ( dynamic_cast<Schrift *>( zSchrift->getThis() ) );
    ret->setText( titel );
    return ret;
}

TextFeld *initTextFeld( int x, int y, int br, int h, Schrift *zSchrift, __int64 style, char *txt )
{
    TextFeld *ret = new TextFeld();
    ret->setStyle( style );
    if( zSchrift )
        ret->setSchriftZ( dynamic_cast<Schrift *>( zSchrift->getThis() ) );
    ret->setText( txt );
    ret->setSchriftFarbe( 0xFFFFFFFF );
    ret->setSchriftSize( 12 );
    if( ret->hatStyle( TextFeld::Style::Buffered ) )
    {
        ret->setAlphaFeldFarbe( 0x5500FF00 );
        ret->setAlphaFeldStrength( -5 );
    }
    if( ret->hatStyle( TextFeld::Style::Rahmen ) )
    {
        ret->setRahmenBreite( 1 );
        ret->setRahmenFarbe( 0xFF00FF00 );
    }
    ret->setPosition( x, y );
    ret->setSize( br, h );
    return ret;
}

Fenster *initFenster( int x, int y, int br, int h, Schrift *zSchrift, __int64 style, char *titel )
{
    Fenster *ret = new Fenster();
    ret->setStyle( style );
    ret->setPosition( x, y );
    ret->setSize( br, h );
    if( ret->hatStyle( Fenster::Style::Rahmen ) )
    {
        ret->setRBreite( 1 );
        ret->setRFarbe( 0xFFFFFFFF );
    }
    if( ret->hatStyle( Fenster::Style::Titel ) )
    {
        ret->setTitel( titel );
        ret->setTSchriftZ( dynamic_cast<Schrift *>( zSchrift->getThis() ) );
        ret->setTSFarbe( 0xFFFFFFFF );
        ret->zTTextFeld()->setSize( 0, 20 );
        ret->zTTextFeld()->addStyle( TextFeld::Style::Sichtbar | TextFeld::Style::Center | TextFeld::Style::Rahmen );
        ret->setTRFarbe( 0xFF00FF00 );
        ret->setTRBreite( 1 );
        if( ret->hatStyle( Fenster::Style::TitelBuffered ) )
        {
            ret->setTAfFarbe( 0x1000FF00 );
            ret->setTAfStrength( -15 );
        }
        if( ret->hatStyle( Fenster::Style::Closable | Fenster::Style::ClosingKlickBuffer ) )
        {
            ret->setSKAfFarbe( 0xFF00FF00 );
            ret->setSKAfStrength( 20 );
        }
    }
    return ret;
}

BildZ *initBildZ( int x, int y, int br, int h, __int64 style, Bild *b )
{
    BildZ *ret = new BildZ();
    ret->setStyle( style );
    ret->setPosition( x, y );
    ret->setSize( br, h );
    if( b )
        ret->setBildZ( b );
    if( ( style | BildZ::Style::Rahmen ) == style )
    {
        ret->setRahmenBreite( 1 );
        ret->setRahmenFarbe( 0xFFFFFFFF );
    }
    return ret;
}