#include <main.h>
#include <Fenster.h>
#include <Punkt.h>
#include <Bildschirm.h>
#include <RenderThread.h>
#include <Knopf.h>
#include <DateiSystem.h>
#include <AuswahlBox.h>
#include <Liste.h>
#include <Schrift.h>
#include <Bild.h>
#include <Text.h>
#include "Initialisierung.h"
#include <MausEreignis.h>
#include <TastaturEreignis.h>
#include <Scroll.h>
#include <AlphaFeld.h>
#include <Rahmen.h>
#include <Datei.h>
#include <DateiDialog.h>
#include <AsynchronCall.h>
#include <Dialog.h>

using namespace Framework;

struct Variablen
{
    // Normale Schrift
    Schrift *nSchrift;
    // Schrift zum Bearbeiten laden
    TextFeld *sPfad;
    Knopf *sLaden;
    Schrift *schrift;
    LTDSDatei *sDatei;
    // Auswhlen der zu Bearbeitenden Zeichen und Gren
    AuswahlListe *gre;
    AuswahlListe *zeichen;
    // Lschen
    Knopf *gLschen;
    Knopf *zLschen;
    // Hinzufgen
    Knopf *neuGre;
    Knopf *neuZeichen;
    // Bearbeiten
    Knopf *editZeichen;
    // Schrift Vorschau
    TextFeld *vorschau;
    TextFeld *vFgT;
    TextFeld *vFg;
    TextFeld *vBgT;
    TextFeld *vBg;
    Knopf *vBgB;
    TextFeld *vGreT;
    TextFeld *vGre;
    AuswahlBox *vStyle;
    // Neue Gre erstellen
    Fenster *neuGreF;
    TextFeld *nGGreT;
    TextFeld *nGGre;
    Knopf *nGOk;
    // Neues Zeichen erstellen
    Fenster *neuZeichenF;
    TextFeld *nZZeichenT;
    TextFeld *nZZeichen;
    TextFeld *nZVorschau;
    TextFeld *nZBreiteT;
    TextFeld *nZBreite;
    TextFeld *nZHheT;
    TextFeld *nZHhe;
    Knopf *nZOk;
    // Zeichen Editor
    Fenster *editF;
    TextFeld *editFgT;
    TextFeld *editFg;
    TextFeld *editBgT;
    TextFeld *editBg;
    TextFeld *editAlphaT;
    TextFeld *editAlpha;
    BildZ *editObj;
    Knopf *editSpeichern;
};

void beenden( void *p, void *obj )
{
    StopNachrichtenSchleife( ( (WFenster *)obj )->getFensterHandle() );
}

void SetErlaubt( bool e, Variablen *var )
{
    if( !e )
    {
        var->sLaden->removeStyle( Knopf::Style::Erlaubt );
        var->gre->removeStyle( AuswahlListe::Style::Erlaubt );
        var->zeichen->removeStyle( AuswahlListe::Style::Erlaubt );
        var->neuGre->removeStyle( Knopf::Style::Erlaubt );
        var->gLschen->removeStyle( Knopf::Style::Erlaubt );
        var->editZeichen->removeStyle( Knopf::Style::Erlaubt );
        var->zLschen->removeStyle( Knopf::Style::Erlaubt );
        var->neuZeichen->removeStyle( Knopf::Style::Erlaubt );
    }
    else
    {
        var->sLaden->addStyle( Knopf::Style::Erlaubt );
        var->gre->addStyle( AuswahlListe::Style::Erlaubt );
        var->zeichen->setStyle( AuswahlListe::Style::Erlaubt, var->gre->getAuswahl() >= 0 );
        var->neuGre->addStyle( AuswahlListe::Style::Erlaubt );
        var->gLschen->setStyle( Knopf::Style::Erlaubt, var->gre->getAuswahl() >= 0 );
        var->editZeichen->setStyle( Knopf::Style::Erlaubt, var->zeichen->getAuswahl() >= 0 );
        var->zLschen->setStyle( Knopf::Style::Erlaubt, var->zeichen->getAuswahl() >= 0 );
        var->neuZeichen->setStyle( Knopf::Style::Erlaubt, var->gre->getAuswahl() >= 0 );
    }
    var->vorschau->addStyle( TextFeld::Style::Erlaubt );
}

void SchriftLaden( Variablen *var )
{
    if( var->schrift )
        var->schrift->release();
    var->schrift = var->sDatei->ladeSchrift();
    if( !var->schrift )
        var->schrift = new Schrift();
    var->vorschau->setSchriftZ( dynamic_cast<Schrift *>( var->schrift->getThis() ) );
    int anz = var->zeichen->getEintragAnzahl();
    for( int i = 0; i < anz; i++ )
        var->zeichen->removeEintrag( 0 );
    var->zeichen->deSelect();
    anz = var->gre->getEintragAnzahl();
    for( int i = 0; i < anz; i++ )
        var->gre->removeEintrag( 0 );
    var->gre->deSelect();
    anz = var->schrift->getAlphabetAnzahl();
    for( int i = 0; i < anz; i++ )
    {
        Text n = "";
        n += var->schrift->zAlphabetI( i )->getSchriftSize();
        var->gre->addEintrag( n );
        var->gre->zEintrag( i )->setSchriftZ( dynamic_cast<Schrift *>( var->nSchrift->getThis() ) );
        var->gre->zEintrag( i )->setSchriftFarbe( 0xFFFFFFFF );
        var->gre->zEintrag( i )->setSize( 0, 20 );
    }
    SetErlaubt( 1, var );
}

bool SLadenME( void *p, void *obj, MausEreignis me )
{
    if( me.id == ME_RLinks )
    {
        Variablen *var = (Variablen *)p;
        if( !DateiExistiert( var->sPfad->getText() ) )
            DateiPfadErstellen( var->sPfad->getText() );
        var->sDatei->setPfad( var->sPfad->getText() );
        var->sDatei->leseDaten();
        SchriftLaden( var );
    }
    return 1;
}

bool GreME( void *p, void *obj, MausEreignis me )
{
    if( me.id == ME_RLinks )
    {
        Variablen *var = (Variablen *)p;
        int anz = var->zeichen->getEintragAnzahl();
        for( int i = 0; i < anz; i++ )
            var->zeichen->removeEintrag( 0 );
        var->zeichen->deSelect();
        var->editZeichen->removeStyle( Knopf::Style::Erlaubt );
        var->zLschen->removeStyle( Knopf::Style::Erlaubt );
        if( var->gre->getKlickEintrag( me.my ) < 0 )
        {
            var->zeichen->removeStyle( AuswahlListe::Style::Erlaubt );
            var->neuZeichen->removeStyle( Knopf::Style::Erlaubt );
            var->gLschen->removeStyle( Knopf::Style::Erlaubt );
            return 1;
        }
        Alphabet *tmp = var->schrift->zAlphabet( (int)*var->gre->zEintrag( var->gre->getKlickEintrag( me.my ) )->zText() );
        for( int c = 1; c < 256; c++ )
        {
            if( !tmp->hatBuchstabe( (unsigned char)c ) )
                continue;
            Text n = "";
            n.append( (char)c );
            n += " (";
            n += (int)c;
            n += ")";
            var->zeichen->addEintrag( n );
            var->zeichen->zEintrag( var->zeichen->getEintragAnzahl() - 1 )->setSchriftZ( dynamic_cast<Schrift *>( var->nSchrift->getThis() ) );
            var->zeichen->zEintrag( var->zeichen->getEintragAnzahl() - 1 )->setSchriftFarbe( 0xFFFFFFFF );
            var->zeichen->zEintrag( var->zeichen->getEintragAnzahl() - 1 )->setSize( 0, 20 );
        }
        var->zeichen->addStyle( AuswahlListe::Style::Erlaubt );
        var->neuZeichen->addStyle( Knopf::Style::Erlaubt );
        var->gLschen->addStyle( Knopf::Style::Erlaubt );
    }
    return 1;
}

bool ZeichenME( void *p, void *obj, MausEreignis me )
{
    if( me.id == ME_RLinks )
    {
        Variablen *var = (Variablen *)p;
        if( var->zeichen->getKlickEintrag( me.my ) < 0 )
        {
            var->editZeichen->removeStyle( Knopf::Style::Erlaubt );
            var->zLschen->removeStyle( Knopf::Style::Erlaubt );
        }
        else
        {
            var->editZeichen->addStyle( Knopf::Style::Erlaubt );
            var->zLschen->addStyle( Knopf::Style::Erlaubt );
        }
    }
    return 1;
}

bool GLschenME( void *p, void *obj, MausEreignis me )
{
    if( me.id == ME_RLinks )
    {
        Variablen *var = (Variablen *)p;
        if( var->gre->getAuswahl() < 0 )
            return 1;
        var->sDatei->lscheSchrifrGre( (int)*var->gre->zEintrag( var->gre->getAuswahl() )->zText() );
        SchriftLaden( var );
    }
    return 1;
}

bool NeuGreME( void *p, void *obj, MausEreignis me )
{
    if( me.id == ME_RLinks )
    {
        Variablen *var = (Variablen *)p;
        var->neuGreF->addStyle( Fenster::Style::Sichtbar );
        SetErlaubt( 0, var );
    }
    return 1;
}

bool NeuGreFME( void *p, void *obj, MausEreignis me )
{
    if( me.id == ME_RLinks )
    {
        Variablen *var = (Variablen *)p;
        var->neuGreF->removeStyle( Fenster::Style::Sichtbar );
        SetErlaubt( 1, var );
    }
    return 1;
}

bool NGOkME( void *p, void *obj, MausEreignis me )
{
    if( me.id == ME_RLinks )
    {
        Variablen *var = (Variablen *)p;
        if( (int)*var->nGGre->zText() <= 0 )
            return 1;
        Alphabet *a = new Alphabet();
        a->setSchriftSize( (int)*var->nGGre->zText() );
        var->sDatei->addSchriftgre( a );
        var->neuGreF->removeStyle( Fenster::Style::Sichtbar );
        SchriftLaden( var );
    }
    return 1;
}

bool VFgTE( void *p, void *obj, TastaturEreignis te )
{
    bool ret = te.taste == T_Enter;
    Variablen *var = (Variablen *)p;
    if( te.taste >= '0' && te.taste <= '9' && var->vFg->zText()->getLength() < 6 )
        ret = 1;
    if( te.taste >= 'A' && te.taste <= 'F' && var->vFg->zText()->getLength() < 6 )
        ret = 1;
    if( te.taste >= 'a' && te.taste <= 'f' && var->vFg->zText()->getLength() < 6 )
        ret = 1;
    if( te.taste == T_Links || te.taste == T_Rechts || te.taste == T_BackSpace || te.taste == T_Entf )
        ret = 1;
    if( !ret )
        return 0;
    Text fgT = "0xFF";
    fgT += var->vFg->zText()->getText();
    for( int i = fgT.getLength(); i < 10; i++ )
        fgT += "0";
    var->vorschau->setSchriftFarbe( 0xFF000000 | (int)fgT );
    return ret;
}

bool VBgTE( void *p, void *obj, TastaturEreignis te )
{
    bool ret = te.taste == T_Enter;
    Variablen *var = (Variablen *)p;
    if( te.taste >= '0' && te.taste <= '9' && var->vBg->zText()->getLength() < 6 )
        ret = 1;
    if( te.taste >= 'A' && te.taste <= 'F' && var->vBg->zText()->getLength() < 6 )
        ret = 1;
    if( te.taste >= 'a' && te.taste <= 'f' && var->vBg->zText()->getLength() < 6 )
        ret = 1;
    if( te.taste == T_Links || te.taste == T_Rechts || te.taste == T_BackSpace || te.taste == T_Entf )
        ret = 1;
    if( !ret )
        return 0;
    Text bgT = "0xFF";
    bgT += var->vBg->zText()->getText();
    for( int i = bgT.getLength(); i < 10; i++ )
        bgT += "0";
    var->vorschau->setHintergrundFarbe( 0xFF000000 | (int)bgT );
    return ret;
}

bool VBgBME( void *p, void *obj, MausEreignis me )
{
    if( me.id == ME_RLinks )
    {
        if( ( (Variablen *)p )->vorschau->hatStyle( TextFeld::Style::HBild ) )
            ( (Variablen *)p )->vorschau->removeStyle( TextFeld::Style::HBild );
        else
        {
            ( (Variablen *)p )->vorschau->addStyle( TextFeld::Style::HBild );
            new AsynchronCall( [p]()
            {
                DateiDialog *dialog = new DateiDialog();
                dialog->addDateiTyp( "Bild Datei", "*.ltdb" );
                Text *path = dialog->anzeigen( 1 );
                if( path )
                {
                    LTDBDatei dat;
                    dat.setDatei( path );
                    dat.leseDaten( 0 );
                    if( dat.getBildAnzahl() )
                    {
                        MultiplChoiceDialog *choice = new MultiplChoiceDialog();
                        for( auto i = dat.zBildListe()->getIterator(); i; i++ )
                        {
                            choice->addChoice( i->getText(), i._ );
                        }
                        Text *zBild = (Text *)choice->anzeigen( ( (Variablen *)p )->nSchrift );
                        if( zBild )
                        {
                            Bild *b = dat.laden( 0, dynamic_cast<Text *>( zBild->getThis() ) );
                            ( (Variablen *)p )->vorschau->setHintergrundBildZ( b );
                        }
                        choice->release();
                    }
                }
                dialog->release();
            } );
        }
    }
    return 1;
}

bool VGreTE( void *p, void *obj, TastaturEreignis te )
{
    bool ret = te.taste == T_Enter;
    Variablen *var = (Variablen *)p;
    if( te.taste >= '0' && te.taste <= '9' && var->vGre->zText()->getLength() < 3 )
        ret = 1;
    if( te.taste == T_Links || te.taste == T_Rechts || te.taste == T_BackSpace || te.taste == T_Entf )
        ret = 1;
    if( !ret )
        return 0;
    var->vorschau->setSchriftSize( (unsigned char)(int)*var->vGre->zText() );
    var->vorschau->updateVScroll();
    return ret;
}

bool NeuZeichenME( void *p, void *obj, MausEreignis me )
{
    if( me.id == ME_RLinks )
    {
        Variablen *var = (Variablen *)p;
        if( var->gre->getAuswahl() < 0 )
            return 1;
        var->neuZeichenF->addStyle( Fenster::Style::Sichtbar );
        SetErlaubt( 0, var );
    }
    return 1;
}

bool NeuZeichenFME( void *p, void *obj, MausEreignis me )
{
    if( me.id == ME_RLinks )
    {
        Variablen *var = (Variablen *)p;
        var->neuZeichenF->removeStyle( Fenster::Style::Sichtbar );
        SetErlaubt( 1, var );
    }
    return 1;
}

bool NZZeichenTE( void *p, void *obj, TastaturEreignis te )
{
    bool ret = te.taste == T_Enter;
    Variablen *var = (Variablen *)p;
    if( te.taste >= '0' && te.taste <= '9' && var->nZZeichen->zText()->getLength() < 3 )
        ret = 1;
    if( te.taste == T_Links || te.taste == T_Rechts || te.taste == T_BackSpace || te.taste == T_Entf )
        ret = 1;
    if( !ret )
        return 0;
    Text v;
    v.append( (char)(int)*var->nZZeichen->zText() );
    var->nZVorschau->setText( v );
    return 1;
}

bool NZOkME( void *p, void *obj, MausEreignis me )
{
    if( me.id == ME_RLinks )
    {
        Variablen *var = (Variablen *)p;
        if( (int)*var->nZBreite->zText() <= 0 || (int)*var->nZHhe->zText() <= 0 || (int)*var->nZZeichen->zText() <= 0 || (int)*var->nZZeichen->zText() > 255 )
            return 1;
        Buchstabe *b = new Buchstabe();
        b->NeuBuchstabe( Punkt( (int)*var->nZBreite->zText(), (int)*var->nZHhe->zText() ) );
        var->sDatei->addBuchstabe( *var->gre->zEintrag( var->gre->getAuswahl() )->zText(), b, (unsigned char)(int)*var->nZZeichen->zText() );
        var->neuZeichenF->removeStyle( Fenster::Style::Sichtbar );
        int ausw = var->gre->getAuswahl();
        SchriftLaden( var );
        MausEreignis me;
        me.id = ME_RLinks;
        me.mx = 20;
        me.my = 50 + ausw * 20 - var->gre->getVertikalScrollPos();
        me.verarbeitet = 0;
        var->gre->doPublicMausEreignis( me );
    }
    return 1;
}

bool ZLschenME( void *p, void *obj, MausEreignis me )
{
    if( me.id == ME_RLinks )
    {
        Variablen *var = (Variablen *)p;
        if( var->gre->getAuswahl() < 0 || var->zeichen->getAuswahl() < 0 )
            return 1;
        var->sDatei->lscheBuchstabe( *var->gre->zEintrag( var->gre->getAuswahl() )->zText(),
                                      (unsigned char)var->zeichen->zEintrag( var->zeichen->getAuswahl() )->zText()->getText()[ 0 ] );
        int ausw = var->gre->getAuswahl();
        SchriftLaden( var );
        MausEreignis me;
        me.id = ME_RLinks;
        me.mx = 20;
        me.my = 50 + ausw * 20 - var->gre->getVertikalScrollPos();
        me.verarbeitet = 0;
        var->gre->doPublicMausEreignis( me );
    }
    return 1;
}

bool EditZeichenME( void *p, void *obj, MausEreignis me )
{
    if( me.id == ME_RLinks )
    {
        Variablen *var = (Variablen *)p;
        if( var->gre->getAuswahl() < 0 || var->zeichen->getAuswahl() < 0 )
            return 1;
        unsigned char zeichen = (unsigned char)var->zeichen->zEintrag( var->zeichen->getAuswahl() )->zText()->getText()[ 0 ];
        int gre = *var->gre->zEintrag( var->gre->getAuswahl() )->zText();
        Alphabet *a = var->schrift->zAlphabet( gre );
        if( !a || !a->hatBuchstabe( zeichen ) )
            return 1;
        Bild *editB = new Bild();
        editB->neuBild( a->zBuchstabe( zeichen )->getSize().x * 10, a->zBuchstabe( zeichen )->getSize().y * 10, 0 );
        var->editObj->setSize( 440 < editB->getBreite() + 2 ? 440 : editB->getBreite() + 2, 390 < editB->getHeight() + 2 ? 390 : editB->getHeight() + 2 );
        var->editObj->setStyle( BildZ::Style::HScroll, 440 < editB->getBreite() + 2 );
        var->editObj->setStyle( BildZ::Style::VScroll, 390 < editB->getHeight() + 2 );
        var->editObj->setBildZ( editB );
        var->editF->addStyle( Fenster::Style::Sichtbar );
        SetErlaubt( 0, var );
    }
    return 1;
}

bool EditFME( void *p, void *obj, MausEreignis me )
{
    if( me.id == ME_RLinks )
    {
        Variablen *var = (Variablen *)p;
        var->editF->removeStyle( Fenster::Style::Sichtbar );
        int gAusw = var->gre->getAuswahl();
        int zAusw = var->zeichen->getAuswahl();
        SchriftLaden( var );
        MausEreignis me;
        me.id = ME_RLinks;
        me.mx = 20;
        me.my = 50 + gAusw * 20 - var->gre->getVertikalScrollPos();
        me.verarbeitet = 0;
        var->gre->doPublicMausEreignis( me );
        me.id = ME_RLinks;
        me.mx = 140;
        me.my = 50 + zAusw * 20 - var->zeichen->getVertikalScrollPos();
        me.verarbeitet = 0;
        var->zeichen->doPublicMausEreignis( me );
    }
    return 1;
}

bool EditObjME( void *p, void *obj, MausEreignis me )
{
    if( me.id == ME_PLinks )
    {
        Variablen *var = (Variablen *)p;
        if( var->editObj->hatStyle( BildZ::Style::VScroll ) && me.mx >= 425 )
            return 1;
        if( var->editObj->hatStyle( BildZ::Style::HScroll ) && me.my >= 375 )
            return 1;
        Text aT = "0x";
        aT += var->editAlpha->zText()->getText();
        for( int i = aT.getLength(); i < 4; i++ )
            aT += "0";
        int a = aT;
        if( a < 0 || a > 255 )
            return 1;
        int px = ( me.mx + var->editObj->getHorizontalScrollPos() ) / 10;
        int py = ( me.my + var->editObj->getVertikalScrollPos() ) / 10;
        Buchstabe *zeichen = var->schrift->zAlphabet( *var->gre->zEintrag( var->gre->getAuswahl() )->zText() )->zBuchstabe(
            (unsigned char)var->zeichen->zEintrag( var->zeichen->getAuswahl() )->zText()->getText()[ 0 ] );
        zeichen->getBuff()[ px + py * zeichen->getSize().x ] = (unsigned char)a;
        var->editObj->setRender();
    }
    return 1;
}

bool EditSpeichernME( void *p, void *obj, MausEreignis me )
{
    if( me.id == ME_RLinks )
    {
        Variablen *var = (Variablen *)p;
        int gr = *var->gre->zEintrag( var->gre->getAuswahl() )->zText();
        unsigned char z = (unsigned char)var->zeichen->zEintrag( var->zeichen->getAuswahl() )->zText()->getText()[ 0 ];
        Buchstabe *zeichen = var->schrift->zAlphabet( gr )->getBuchstabe( z );
        var->sDatei->lscheBuchstabe( gr, z );
        var->sDatei->addBuchstabe( gr, zeichen, z );
    }
    return 1;
}

bool TestME( void *p, void *obj, MausEreignis me )
{
    if( me.id == ME_PLinks )
    {
        return 1;
    }
    return 1;
}

void renderE( void *p, void *obj, Bild *zRObj )
{
    Variablen *var = (Variablen *)p;
    if( var->editF->hatStyle( Fenster::Style::Sichtbar ) )
    {
        Buchstabe *zeichen = var->schrift->zAlphabet( *var->gre->zEintrag( var->gre->getAuswahl() )->zText() )->zBuchstabe(
            (unsigned char)var->zeichen->zEintrag( var->zeichen->getAuswahl() )->zText()->getText()[ 0 ] );
        Text fgT = "0x00";
        fgT += var->editFg->zText()->getText();
        for( int i = fgT.getLength(); i < 10; i++ )
            fgT += "0";
        int fg = fgT;
        Text bgT = "0xFF";
        bgT += var->editBg->zText()->getText();
        for( int i = bgT.getLength(); i < 10; i++ )
            bgT += "0";
        var->editObj->zBild()->fillRegion( 0, 0, var->editObj->zBild()->getBreite(), var->editObj->zBild()->getHeight(), bgT );
        for( int i = 0; i < zeichen->getSize().x; i++ )
        {
            for( int j = 0; j < zeichen->getSize().y; j++ )
                var->editObj->zBild()->alphaRegion( i * 10, j * 10, 10, 10, ( zeichen->getBuff()[ i + j * zeichen->getSize().x ] << 24 ) | fg );
        }
    }
}

int KSGStart Framework::Start( Startparam p )
{
    Variablen var;

    WNDCLASS wc = F_Normal( p.hinst );
    wc.lpszClassName = "Schrift Editor 2.0";
    WFenster *f = new WFenster();
    f->setVSchlieAktion( beenden );
    f->setMausAktion( TestME );
    f->setTastaturAktion( _ret1TE );
    f->erstellen( WS_OVERLAPPEDWINDOW, wc );
    f->setSize( 750, 730 );
    f->setPosition( Bildschirmmitte( dynamic_cast<WFenster *>( f->getThis() ) ) );
    f->setVerschiebbar( 1 );
    f->setAnzeigeModus( 1 );

    Bildschirm *b = new Bildschirm3D( dynamic_cast<WFenster *>( f->getThis() ) );
    f->setBildschirm( dynamic_cast<Bildschirm *>( b->getThis() ) );
    b->update();

    RenderTh *r = new RenderTh();
    r->setBildschirm( dynamic_cast<Bildschirm *>( b->getThis() ) );
    r->beginn();

    LTDSDatei *sND = new LTDSDatei();
    sND->setPfad( new Text( "../data/normal.ltds" ) );
    sND->leseDaten();
    var.nSchrift = sND->ladeSchrift();
    sND->release();

    var.schrift = 0;
    var.sDatei = new LTDSDatei();

    var.sPfad = initTextFeld( 10, 10, 620, 20, var.nSchrift, TextFeld::Style::TextFeld | TextFeld::Style::VCenter, "LTDS Datei Pfad" );
    b->addMember( var.sPfad );

    var.sLaden = initKnopf( 640, 10, 100, 20, var.nSchrift, Knopf::Style::Sichtbar, "LTDS Laden" );
    var.sLaden->setMausEreignis( SLadenME );
    var.sLaden->setMausEreignisParameter( &var );
    b->addMember( var.sLaden );

    var.gre = new AuswahlListe();
    var.gre->setStyle( AuswahlListe::Style::Sichtbar | AuswahlListe::Style::Rahmen | AuswahlListe::Style::AuswahlBuffer | AuswahlListe::Style::AuswahlRahmen | AuswahlListe::Style::VScroll );
    var.gre->setPosition( 10, 40 );
    var.gre->setSize( 100, 590 );
    var.gre->setAlphaFeldFarbe( 0x7500FF00 );
    var.gre->setAlphaFeldStrength( 8 );
    var.gre->setRahmenFarbe( 0xFFFFFFFF );
    var.gre->setRahmenBreite( 2 );
    var.gre->setALRZ( new LRahmen() );
    var.gre->zARahmen()->setFarbe( 0xFF00FF00 );
    var.gre->setVertikalKlickScroll( 10 );
    var.gre->setMausEreignis( GreME );
    var.gre->setMausEreignisParameter( &var );
    var.gre->update();
    b->addMember( var.gre );

    var.zeichen = new AuswahlListe();
    var.zeichen->setStyle( AuswahlListe::Style::Sichtbar | AuswahlListe::Style::Rahmen | AuswahlListe::Style::AuswahlBuffer | AuswahlListe::Style::AuswahlRahmen | AuswahlListe::Style::VScroll );
    var.zeichen->setPosition( 120, 40 );
    var.zeichen->setSize( 105, 560 );
    var.zeichen->setAlphaFeldFarbe( 0x7500FF00 );
    var.zeichen->setAlphaFeldStrength( 8 );
    var.zeichen->setRahmenFarbe( 0xFFFFFFFF );
    var.zeichen->setRahmenBreite( 2 );
    var.zeichen->setALRZ( new LRahmen() );
    var.zeichen->zARahmen()->setFarbe( 0xFF00FF00 );
    var.zeichen->setVertikalKlickScroll( 10 );
    var.zeichen->setMausEreignis( ZeichenME );
    var.zeichen->setMausEreignisParameter( &var );
    var.zeichen->update();
    b->addMember( var.zeichen );

    var.gLschen = initKnopf( 10, 640, 100, 20, var.nSchrift, Knopf::Style::Sichtbar, "Gre Lschen" );
    var.gLschen->removeStyle( Knopf::Style::Erlaubt );
    var.gLschen->setMausEreignis( GLschenME );
    var.gLschen->setMausEreignisParameter( &var );
    b->addMember( var.gLschen );

    var.neuGre = initKnopf( 10, 670, 100, 20, var.nSchrift, Knopf::Style::Sichtbar, "Neue Gre" );
    var.neuGre->removeStyle( Knopf::Style::Erlaubt );
    var.neuGre->setMausEreignis( NeuGreME );
    var.neuGre->setMausEreignisParameter( &var );
    b->addMember( var.neuGre );

    var.editZeichen = initKnopf( 120, 610, 105, 20, var.nSchrift, Knopf::Style::Sichtbar, "Zeichen ndern" );
    var.editZeichen->removeStyle( Knopf::Style::Erlaubt );
    var.editZeichen->setMausEreignis( EditZeichenME );
    var.editZeichen->setMausEreignisParameter( &var );
    b->addMember( var.editZeichen );

    var.zLschen = initKnopf( 120, 640, 105, 20, var.nSchrift, Knopf::Style::Sichtbar, "Zeichen Lschen" );
    var.zLschen->removeStyle( Knopf::Style::Erlaubt );
    var.zLschen->setMausEreignis( ZLschenME );
    var.zLschen->setMausEreignisParameter( &var );
    b->addMember( var.zLschen );

    var.neuZeichen = initKnopf( 120, 670, 105, 20, var.nSchrift, Knopf::Style::Sichtbar, "Neues Zeichen" );
    var.neuZeichen->removeStyle( Knopf::Style::Erlaubt );
    var.neuZeichen->setMausEreignis( NeuZeichenME );
    var.neuZeichen->setMausEreignisParameter( &var );
    b->addMember( var.neuZeichen );

    var.vorschau = initTextFeld( 230, 40, 510, 150, 0, TextFeld::Style::TextGebiet & ~TextFeld::Style::Erlaubt, "Vorschau" );
    b->addMember( var.vorschau );

    var.vFgT = initTextFeld( 230, 200, 40, 20, var.nSchrift, TextFeld::Style::Text | TextFeld::Style::VCenter, "Farbe:" );
    b->addMember( var.vFgT );

    var.vFg = initTextFeld( 270, 200, 60, 20, var.nSchrift, TextFeld::Style::TextFeld, "FFFFFF" );
    var.vFg->setTastaturEreignis( VFgTE );
    var.vFg->setTastaturEreignisParameter( &var );
    b->addMember( var.vFg );

    var.vBgT = initTextFeld( 340, 200, 80, 20, var.nSchrift, TextFeld::Style::Text | TextFeld::Style::VCenter, "Hintergrund:" );
    b->addMember( var.vBgT );

    var.vBg = initTextFeld( 415, 200, 60, 20, var.nSchrift, TextFeld::Style::TextFeld, "000000" );
    var.vBg->setTastaturEreignis( VBgTE );
    var.vBg->setTastaturEreignisParameter( &var );
    b->addMember( var.vBg );

    var.vBgB = initKnopf( 485, 200, 50, 20, var.nSchrift, Knopf::Style::Normal, "Bild" );
    var.vBgB->setMausEreignis( VBgBME );
    var.vBgB->setMausEreignisParameter( &var );
    b->addMember( var.vBgB );

    var.vGreT = initTextFeld( 550, 200, 50, 20, var.nSchrift, TextFeld::Style::Text | TextFeld::Style::VCenter, "Gre:" );
    b->addMember( var.vGreT );

    var.vGre = initTextFeld( 600, 200, 60, 20, var.nSchrift, TextFeld::Style::TextFeld, "12" );
    var.vGre->setTastaturEreignis( VGreTE );
    var.vGre->setTastaturEreignisParameter( &var );
    b->addMember( var.vGre );

    var.vStyle = new AuswahlBox();
    var.vStyle->setPosition( 670, 200 );
    var.vStyle->setSize( 70, 20 );
    var.vStyle->setHintergrundFarbe( 0xFF000000 );
    var.vStyle->setRahmenBreite( 1 );
    var.vStyle->setRahmenFarbe( 0xFFFFFFFF );
    var.vStyle->setMaxAuskappHeight( 120 );
    var.vStyle->setMausRahmenBreite( 1 );
    var.vStyle->setMausRahmenFarbe( 0xFF005500 );
    var.vStyle->setMausAlphaFeldFarbe( 0x00008700 );
    var.vStyle->setMausAlphaFeldStrength( -8 );
    var.vStyle->setAuswRahmenBreite( 1 );
    var.vStyle->setAuswRahmenFarbe( 0xFF00FF00 );
    var.vStyle->setAuswAlphaFeldFarbe( 0x0000FF00 );
    var.vStyle->setAuswAlphaFeldStrength( -8 );
    var.vStyle->setStyle( AuswahlBox::Style::Normal );
    var.vStyle->setSchriftZ( dynamic_cast<Schrift *>( var.nSchrift->getThis() ) );
    var.vStyle->addEintrag( "Normal" );
    var.vStyle->addEintrag( "Gravur" );
    var.vStyle->setMausEreignis( _ret1ME );
    var.vStyle->setEventAktion( [var]( void *p, AuswahlBox *o, int alt, int neu )
    {
        switch( neu )
        {
        case 0:
            var.vorschau->setTextRendererZ( new TextRenderer( var.schrift ) );
            break;
        case 1:
            var.vorschau->setTextRendererZ( new GravurTextRenderer( var.schrift ) );
            break;
        }
    } );
    b->addMember( var.vStyle );

    var.editF = initFenster( 230, 230, 460, 460, var.nSchrift, Fenster::Style::normal | Fenster::Style::TitelHintergrund | Fenster::Style::BodyHintergrund | Fenster::Style::ClosingHintergrund, "Zeichen Editor" );
    var.editF->setClosingMe( EditFME );
    var.editF->setClosingMeParam( &var );
    var.editF->removeStyle( Fenster::Style::Sichtbar );
    b->addMember( var.editF );

    var.editObj = initBildZ( 10, 10, 440, 390, BildZ::Style::Sichtbar | BildZ::Style::HScroll | BildZ::Style::VScroll | BildZ::Style::Rahmen | BildZ::Style::Erlaubt, 0 );
    var.editObj->setMausEreignis( EditObjME );
    var.editObj->setMausEreignisParameter( &var );
    var.editF->addMember( var.editObj );

    var.editFgT = initTextFeld( 10, 410, 80, 20, var.nSchrift, TextFeld::Style::Text | TextFeld::Style::VCenter, "Vordergrund:" );
    var.editF->addMember( var.editFgT );

    var.editFg = initTextFeld( 90, 410, 60, 20, var.nSchrift, TextFeld::Style::TextFeld, "FFFFFF" );
    var.editFg->setTastaturEreignis( _nurHexTE );
    var.editF->addMember( var.editFg );

    var.editBgT = initTextFeld( 160, 410, 80, 20, var.nSchrift, TextFeld::Style::Text | TextFeld::Style::VCenter, "Hintergrund:" );
    var.editF->addMember( var.editBgT );

    var.editBg = initTextFeld( 240, 410, 60, 20, var.nSchrift, TextFeld::Style::TextFeld, "000000" );
    var.editBg->setTastaturEreignis( _nurHexTE );
    var.editF->addMember( var.editBg );

    var.editAlphaT = initTextFeld( 310, 410, 40, 20, var.nSchrift, TextFeld::Style::Text | TextFeld::Style::VCenter, "Alpha:" );
    var.editF->addMember( var.editAlphaT );

    var.editAlpha = initTextFeld( 350, 410, 30, 20, var.nSchrift, TextFeld::Style::TextFeld, "FF" );
    var.editAlpha->setTastaturEreignis( _nurHexTE );
    var.editF->addMember( var.editAlpha );

    var.editSpeichern = initKnopf( 390, 410, 60, 20, var.nSchrift, Knopf::Style::Sichtbar, "Save" );
    var.editSpeichern->setMausEreignis( EditSpeichernME );
    var.editSpeichern->setMausEreignisParameter( &var );
    var.editF->addMember( var.editSpeichern );

    var.neuGreF = initFenster( 290, 305, 120, 90, var.nSchrift, Fenster::Style::normal | Fenster::Style::TitelHintergrund | Fenster::Style::BodyHintergrund | Fenster::Style::ClosingHintergrund, "Neue Gre" );
    var.neuGreF->setClosingMe( NeuGreFME );
    var.neuGreF->setClosingMeParam( &var );
    var.neuGreF->removeStyle( Fenster::Style::Sichtbar );
    b->addMember( var.neuGreF );

    var.nGGreT = initTextFeld( 10, 10, 50, 20, var.nSchrift, TextFeld::Style::Text | TextFeld::Style::VCenter, "Gre:" );
    var.neuGreF->addMember( var.nGGreT );

    var.nGGre = initTextFeld( 60, 10, 50, 20, var.nSchrift, TextFeld::Style::TextFeld, "12" );
    var.nGGre->setTastaturEreignis( _nurNummernTE );
    var.neuGreF->addMember( var.nGGre );

    var.nGOk = initKnopf( 10, 40, 100, 20, var.nSchrift, Knopf::Style::Sichtbar, "Ok" );
    var.nGOk->setMausEreignis( NGOkME );
    var.nGOk->setMausEreignisParameter( &var );
    var.neuGreF->addMember( var.nGOk );

    var.neuZeichenF = initFenster( 290, 275, 120, 150, var.nSchrift, Fenster::Style::normal | Fenster::Style::TitelHintergrund | Fenster::Style::BodyHintergrund | Fenster::Style::ClosingHintergrund, "Neues Zeichen" );
    var.neuZeichenF->setClosingMe( NeuZeichenFME );
    var.neuZeichenF->setClosingMeParam( &var );
    var.neuZeichenF->removeStyle( Fenster::Style::Sichtbar );
    b->addMember( var.neuZeichenF );

    var.nZZeichenT = initTextFeld( 10, 10, 60, 20, var.nSchrift, TextFeld::Style::Text | TextFeld::Style::VCenter, "Zeichen:" );
    var.neuZeichenF->addMember( var.nZZeichenT );

    var.nZZeichen = initTextFeld( 70, 10, 30, 20, var.nSchrift, TextFeld::Style::TextFeld, "" );
    var.nZZeichen->setTastaturEreignis( NZZeichenTE );
    var.nZZeichen->setTastaturEreignisParameter( &var );
    var.neuZeichenF->addMember( var.nZZeichen );

    var.nZVorschau = initTextFeld( 105, 10, 10, 20, var.nSchrift, TextFeld::Style::Text | TextFeld::Style::VCenter, "" );
    var.neuZeichenF->addMember( var.nZVorschau );

    var.nZBreiteT = initTextFeld( 10, 40, 50, 20, var.nSchrift, TextFeld::Style::Text | TextFeld::Style::VCenter, "Breite" );
    var.neuZeichenF->addMember( var.nZBreiteT );

    var.nZBreite = initTextFeld( 60, 40, 50, 20, var.nSchrift, TextFeld::Style::TextFeld, "" );
    var.nZBreite->setTastaturEreignis( _nurNummernTE );
    var.neuZeichenF->addMember( var.nZBreite );

    var.nZHheT = initTextFeld( 10, 70, 50, 20, var.nSchrift, TextFeld::Style::Text | TextFeld::Style::VCenter, "Hhe" );
    var.neuZeichenF->addMember( var.nZHheT );

    var.nZHhe = initTextFeld( 60, 70, 50, 20, var.nSchrift, TextFeld::Style::TextFeld, "" );
    var.nZHhe->setTastaturEreignis( _nurNummernTE );
    var.neuZeichenF->addMember( var.nZHhe );

    var.nZOk = initKnopf( 10, 100, 100, 20, var.nSchrift, Knopf::Style::Sichtbar, "Ok" );
    var.nZOk->setMausEreignis( NZOkME );
    var.nZOk->setMausEreignisParameter( &var );
    var.neuZeichenF->addMember( var.nZOk );

    r->setRenderFunktionParameter( &var );
    r->setRenderFunktion( renderE );

    StartNachrichtenSchleife();

    r->beenden();
    r->release();

    var.nSchrift->release();
    if( var.schrift )
        var.schrift->release();
    var.sDatei->release();

    b->release();
    f->setBildschirm( 0 );
    f->setAnzeigeModus( 0 );
    f->zerstren();
    f->release();

    return 0;
}